<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />
    <meta name="description" content="" />
    <meta name="author" content="" />

    <title></title>

    <!-- Custom fonts for this template-->

    <link
      href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
      rel="stylesheet"
    />

    <!-- Custom styles for this template-->
    <link href="css/sb-admin-2.min.css" rel="stylesheet" />
    <link
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.13.0/css/all.min.css"
      rel="stylesheet"
      type="text/css"
    />
    <link
      href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
      rel="stylesheet"
    />

    <link
      href="https://cdn.jsdelivr.net/npm/startbootstrap-sb-admin-2@4.0.7/css/sb-admin-2.min.css"
      rel="stylesheet"
    />
    <link
      rel="stylesheet"
      type="text/css"
      href="https://cdn.datatables.net/v/dt/jszip-2.5.0/dt-1.12.1/b-2.2.3/b-colvis-2.2.3/b-html5-2.2.3/b-print-2.2.3/cr-1.5.6/fh-3.2.4/kt-2.7.0/r-2.3.0/rg-1.2.0/rr-1.2.8/sc-2.0.7/sb-1.3.4/sp-2.0.2/sl-1.4.0/datatables.min.css"
    />
  </head>

  <body id="page-top">
    <!-- Page Wrapper -->
    <div id="wrapper">
      <!-- Sidebar -->
      <ul
        class="navbar-nav bg-gradient-primary sidebar sidebar-dark accordion"
        id="accordionSidebar"
      >
        <!-- Sidebar - Brand -->
        <a
          class="sidebar-brand d-flex align-items-center justify-content-center"
          href="index.html"
        >
          <div class="sidebar-brand-icon rotate-n-15">
            <img src="img/logo.png" width="20" />
          </div>
          <div class="sidebar-brand-text mx-3">dsplus<sup></sup></div>
        </a>

        <!-- Divider -->
        <hr class="sidebar-divider my-0" />

        <!-- Nav Item - Dashboard -->
        <li class="nav-item">
          <a class="nav-link" href="index.html">
            <i class="fas fa-fw fa-tachometer-alt"></i>
            <span>Dashboard</span></a
          >
        </li>

        <!-- Divider -->
        <hr class="sidebar-divider" />

        <!-- Heading -->

        <!-- Heading -->

        <!-- Nav Item - Projects Collapse Menu -->
        <li class="nav-item active">
          <a
            class="nav-link"
            href="#"
            data-toggle="collapse"
            data-target="#collapseProjects"
            aria-expanded="true"
            aria-controls="collapseProjects"
          >
            <i class="fas fa-fw fa-folder"></i>
            <span>Projects</span>
          </a>
          <div
            id="collapseProjects"
            class="collapse"
            aria-labelledby="headingProjects"
            data-parent="#accordionSidebar"
          >
            <div
              class="bg-white py-2 collapse-inner rounded"
              id="projects"
            ></div>
          </div>
        </li>

        <!-- Divider -->
        <hr class="sidebar-divider d-none d-md-block" />

        <!-- Sidebar Toggler (Sidebar) -->
        <div class="text-center d-none d-md-inline">
          <button class="rounded-circle border-0" id="sidebarToggle"></button>
        </div>
      </ul>
      <!-- End of Sidebar -->

      <!-- Content Wrapper -->
      <div id="content-wrapper" class="d-flex flex-column">
        <!-- Main Content -->
        <div id="content">
          <!-- Topbar -->
          <nav
            class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow"
          >
            <!-- Sidebar Toggle (Topbar) -->
            <button
              id="sidebarToggleTop"
              class="btn btn-link d-md-none rounded-circle mr-3"
            >
              <i class="fa fa-bars"></i>
            </button>

            <!-- Topbar Navbar -->
            <ul class="navbar-nav ml-auto">
              <!-- Nav Item - Search Dropdown (Visible Only XS) -->
              <li class="nav-item dropdown no-arrow d-sm-none">
                <a
                  class="nav-link dropdown-toggle"
                  href="#"
                  id="searchDropdown"
                  role="button"
                  data-toggle="dropdown"
                  aria-haspopup="true"
                  aria-expanded="false"
                >
                  <i class="fas fa-search fa-fw"></i>
                </a>
                <!-- Dropdown - Messages -->
                <div
                  class="dropdown-menu dropdown-menu-right p-3 shadow animated--grow-in"
                  aria-labelledby="searchDropdown"
                >
                  <form class="form-inline mr-auto w-100 navbar-search">
                    <div class="input-group">
                      <input
                        type="text"
                        class="form-control bg-light border-0 small"
                        placeholder="Search for..."
                        aria-label="Search"
                        aria-describedby="basic-addon2"
                      />
                      <div class="input-group-append">
                        <button class="btn btn-primary" type="button">
                          <i class="fas fa-search fa-sm"></i>
                        </button>
                      </div>
                    </div>
                  </form>
                </div>
              </li>
            </ul>
          </nav>
          <!-- End of Topbar -->

          <!-- Begin Page Content -->
          <div class="container-fluid">
            <!-- Page Heading -->

            <!-- Page Heading -->
            <div
              class="d-sm-flex align-items-center justify-content-between mb-4"
            >
              <h1 class="h3 mb-4 text-gray-800" id="project"></h1>
              <a
                href="#"
                id="raw"
                class="d-none d-sm-inline-block btn btn-sm btn-primary shadow-sm"
                ><i class="fas fa-magnifying-glass fa-sm text-white-50"></i>View
                Raw</a
              >
            </div>
            <div class="row">
              <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-info text-uppercase mb-1"
                        >
                          Complexity
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="complexity"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-brain fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-xl-3 col-md-6 mb-4" id="costdiv">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-info text-uppercase mb-1"
                        >
                          Cost
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cost"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-industry fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-info text-uppercase mb-1"
                        >
                          Size
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="size"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-weight fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-warning shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-warning text-uppercase mb-1"
                        >
                          Issues
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="issues"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i
                          class="fas fa-exclamation-circle fa-2x text-gray-300"
                        ></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="row">
              <div class="col text-center">
                <div class="card shadow mb-4">
                  <img id="image" class="rounded img-fluid" />
                </div>
              </div>
            </div>
            <div class="row mb-4">
              <div class="col">
                <div class="card shadow mb-4 h-100">
                  <div class="card-header py-3">
                    <h6 class="m-0 font-weight-bold text-primary">
                      Documentation
                    </h6>
                  </div>
                  <div class="card-body" id="documentation"></div>
                </div>
              </div>
              <div class="col">
                <div class="card shadow mb-4 h-100">
                  <div class="card-header py-3 ">
                    <h6 class="m-0 font-weight-bold text-primary">
                      Metadata
                    </h6>
                  </div>
                  <div class="card-body" id="metadata"></div>
                </div>
              </div>
            </div>
            <div class="row">
              <div class="col-sm-2 mb-4 d-none" id="blocker">
                <div class="card border-left-danger shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Blocker
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cblocker"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-radiation fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-sm-2 mb-4 d-none" id="critical">
                <div class="card border-left-danger shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Critical
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="ccritical"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-bomb fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-sm-2 mb-4 d-none" id="major">
                <div class="card border-left-warning shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Major
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cmajor"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-times fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-sm-2 mb-4 d-none" id="minor">
                <div class="card border-left-primary shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Minor
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cminor"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i
                          class="fas fa-exclamation-circle fa-2x text-gray-300"
                        ></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-sm-2 mb-4 d-none" id="info">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Information
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cinfo"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-info fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <!-- /.container-fluid -->
            <div class="row">
              <div class="col">
                <div class="card shadow mb-4">
                  <div class="card-header py-3">
                    <h6 class="m-0 font-weight-bold text-primary">Issues</h6>
                  </div>
                  <div class="card-body">
                    <div class="table-responsive">
                      <table
                        class="table table-bordered"
                        id="dataTable"
                        width="100%"
                        cellspacing="0"
                      >
                        <thead>
                          <tr>
                            <th>Rule</th>
                            <th>Name</th>
                            <th>Category</th>
                            <th>Severity</th>
                            <th>Categories</th>
                            <th>Message</th>
                            <th>Expected</th>
                            <th>Actual</th>
                          </tr>
                        </thead>
                        <tbody></tbody>
                        <tfoot>
                          <tr>
                            <th>Rule</th>
                            <th>Name</th>
                            <th>Category</th>
                            <th>Severity</th>
                            <th>Categories</th>
                            <th>Message</th>
                            <th>Expected</th>
                            <th>Actual</th>
                          </tr>
                        </tfoot>
                      </table>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- End of Main Content -->

          <!-- Footer -->

          <!-- End of Footer -->
        </div>
        <!-- End of Content Wrapper -->
      </div>
    </div>
    <!-- End of Page Wrapper -->

    <!-- Scroll to Top Button-->
    <a class="scroll-to-top rounded" href="#page-top">
      <i class="fas fa-angle-up"></i>
    </a>

    <!-- Logout Modal-->
 <!-- Button trigger modal -->

    <!-- Bootstrap core JavaScript-->

    <!-- Custom scripts for all Projects-->
  </body>
</html>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.4.1/js/bootstrap.bundle.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.4.1/jquery.easing.min.js"></script>

<script src="js/sb-admin-2.min.js"></script>
<script
  type="text/javascript"
  src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/pdfmake.min.js"
></script>
<script
  type="text/javascript"
  src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/vfs_fonts.js"
></script>
<script
  type="text/javascript"
  src="https://cdn.datatables.net/v/dt/jszip-2.5.0/dt-1.12.1/b-2.2.3/b-colvis-2.2.3/b-html5-2.2.3/b-print-2.2.3/cr-1.5.6/fh-3.2.4/kt-2.7.0/r-2.3.0/rg-1.2.0/rr-1.2.8/sc-2.0.7/sb-1.3.4/sp-2.0.2/sl-1.4.0/datatables.min.js"
></script>

<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.2.2/Chart.bundle.min.js"></script>
<script src="https://unpkg.com/showdown/dist/showdown.min.js"></script>

<script type="text/javascript">
  const types = {
    '0': 'server',
    '2': 'sequence',
    '3': 'px'
  }
  $(document).ready(function (e) {
    const queryString = window.location.search;
    const urlParams = new URLSearchParams(queryString);
    const project = urlParams.get("project");
    const asset = urlParams.get("asset");
    const path =
      "data/" + project + urlParams.get("category") + "/" + asset + "/" + asset;
    const category = $("#project").text(project);

    document.title = project;
    $.getJSON("data/projects.json", function (data) {
      data.map((p) => {
        $("#projects").append(
          `<a class="collapse-item" href="issues.html?project=${p.name}">${p.name}</a>`
        );
      });
    });

    $.getJSON(path + ".json", function (metadata) {
      //console.log(metadata);
      $("#project").text(`${project}${metadata.category}/${metadata.name}`);
      $("#documentation").html(
        `<div style="font-weight: bold;">${metadata.shortDescription}</div>`
      );
      Object.keys(metadata).filter(m=>['modificationTimestamp','creationTimestamp','createdByUser','modifiedByUser','category','jobType'].includes(m)).map(m => {
        if (m==='jobType') {
          if (metadata[m] == "2") {
            $('#costdiv').addClass('d-none')
          }
          metadata[m]=types[metadata[m]]

        }
        $("#metadata").append(
        `<div><a style="font-weight: bold;">${m}</a>: ${metadata[m]}</div>`
      );
      })
  
      document.title = `${project}${metadata.category}/${metadata.name}`;
      //alert(metadata.type)
      if (metadata.type === "job") {
        $("#raw").attr("href", path + ".ast.json");
        $("#image").attr("src", path + ".png");
        $.getJSON(path + ".ast.json", function (ast) {
          $("#size").text(ast.metrics.size);
          $("#complexity").text(ast.metrics.complexity);
          $("#cost").text(ast.metrics.cost);
          var converter = new showdown.Converter(),
            text = ast.longDescription,
            html = converter.makeHtml(text);
          $("#documentation").append(`<div>${html}</div>`);
        });
      } else {
        $("#raw").attr("href", path + ".json");
      }
    });

    $.getJSON("data/" + project + ".issues.json", function (issues) {
      var counters = {};

      var issues = issues.issues
        .filter((i) => i.name === asset)
        .map((i) => {
          i.categories = (i.categories || []).join(",");
          counters[i.severity] = (counters[i.severity] || 0) + 1;
          return i;
        });
      //console.log(issues)
      $("#issues").text(issues.length);

      Object.keys(counters).map((c) => {
        $("#c" + c).text(counters[c]);
        $("#" + c).removeClass("d-none");
      });
      var table = $("#dataTable").DataTable({
        data: issues,
        columns: [
          { data: "rule", defaultContent: "" },
          { data: "name", defaultContent: "" },
          { data: "category", defaultContent: "" },
          { data: "severity", defaultContent: "" },
          { data: "categories", defaultContent: "" },
          { data: "message", defaultContent: "" },
          { data: "expected", defaultContent: "" },
          { data: "actual", defaultContent: "" },
        ],
        fixedHeader: true,
        colReorder: true,
        dom: "BRSPfrtipl",
        buttons: [
          "colvis",
          {
            extend: "copyHtml5",
            exportOptions: {
              columns: ":visible",
            },
          },
          {
            extend: "excelHtml5",
            exportOptions: {
              columns: ":visible",
            },
          },
          {
            extend: "csvHtml5",
            exportOptions: {
              columns: ":visible",
            },
          },
          {
            extend: "pdfHtml5",
            exportOptions: {
              columns: ":visible",
            },
          },
          {
            extend: "print",
            exportOptions: {
              columns: ":visible",
            },
          },
        ],
        columnDefs: [
          {
            searchPanes: {
              show: true,
            },
            targets: [0, 1, 2, 3, 4],
          },
          {
            searchPanes: {
              show: false,
            },
            targets: [5, 6, 7],
          },
        ],
        searchPanes: {
          initCollapsed: true,
        },
      });
    });
  });
</script>
